Trades
List All Trades
This endpoint lists all trades and can be used in streaming mode. Streaming mode allows you to listen for new trades as they are added to the Stellar ledger. If called in streaming mode, Horizon will start at the earliest known trade unless a cursor is set, in which case it will start from that cursor. By setting the cursor value to now, you can stream trades created since your request time. When filtering for a specific orderbook, you must use use all six of these arguments: base_asset_type, base_asset_issuer, base_asset_code, counter_asset_type, counter_asset_issuer, and counter_asset_code. If the base or counter asset is XLM, you only need to indicate the asset type as native and do not need to designate the code or the issuer.
GET
/
trades
List All Trades
curl --request GET \
--url https://horizon-testnet.stellar.org/tradesimport requests
url = "https://horizon-testnet.stellar.org/trades"
response = requests.get(url)
print(response.text)const options = {method: 'GET'};
fetch('https://horizon-testnet.stellar.org/trades', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://horizon-testnet.stellar.org/trades",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "GET",
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://horizon-testnet.stellar.org/trades"
req, _ := http.NewRequest("GET", url, nil)
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.get("https://horizon-testnet.stellar.org/trades")
.asString();require 'uri'
require 'net/http'
url = URI("https://horizon-testnet.stellar.org/trades")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
response = http.request(request)
puts response.read_body{
"_links": {
"self": {
"href": "https://horizon-testnet.stellar.org/trades?base_asset_code=USD&base_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX&base_asset_type=credit_alphanum4&counter_asset_type=native&cursor=&limit=3&order=asc"
},
"next": {
"href": "https://horizon-testnet.stellar.org/trades?base_asset_code=USD&base_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX&base_asset_type=credit_alphanum4&counter_asset_type=native&cursor=83056000260648961-0&limit=3&order=asc"
},
"prev": {
"href": "https://horizon-testnet.stellar.org/trades?base_asset_code=USD&base_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX&base_asset_type=credit_alphanum4&counter_asset_type=native&cursor=82854686553571330-0&limit=3&order=desc"
}
},
"_embedded": {
"records": [
{
"_links": {
"self": {
"href": ""
},
"base": {
"href": "https://horizon-testnet.stellar.org/accounts/GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS"
},
"counter": {
"href": "https://horizon-testnet.stellar.org/accounts/GBCHK52UXADCQCO7FBA5VBYPGCJFXHCNAVJTMUEKOCCNKJH5F35UZU5T"
},
"operation": {
"href": "https://horizon-testnet.stellar.org/operations/82854686553571330"
}
},
"id": "82854686553571330-0",
"paging_token": "82854686553571330-0",
"ledger_close_time": "2018-08-05T00:55:34Z",
"offer_id": "23074703",
"base_offer_id": "23074703",
"base_account": "GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS",
"base_amount": "22.9174941",
"base_asset_type": "credit_alphanum4",
"base_asset_code": "USD",
"base_asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
"counter_offer_id": "4694540704980959234",
"counter_account": "GBCHK52UXADCQCO7FBA5VBYPGCJFXHCNAVJTMUEKOCCNKJH5F35UZU5T",
"counter_amount": "97.9999800",
"counter_asset_type": "native",
"base_is_seller": true,
"price": {
"n": "106905209",
"d": "25000000"
}
},
{
"_links": {
"self": {
"href": ""
},
"base": {
"href": "https://horizon-testnet.stellar.org/accounts/GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS"
},
"counter": {
"href": "https://horizon-testnet.stellar.org/accounts/GDURV3I6U5OTUV75WWAG2HWZTQHNMCR3NR2P5GPKDCIS2AEWCFSOLVFU"
},
"operation": {
"href": "https://horizon-testnet.stellar.org/operations/83005225157287937"
}
},
"id": "83005225157287937-0",
"paging_token": "83005225157287937-0",
"ledger_close_time": "2018-08-07T02:01:53Z",
"offer_id": "23400441",
"base_offer_id": "23400441",
"base_account": "GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS",
"base_amount": "1.0000000",
"base_asset_type": "credit_alphanum4",
"base_asset_code": "USD",
"base_asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
"counter_offer_id": "4694691243584675841",
"counter_account": "GDURV3I6U5OTUV75WWAG2HWZTQHNMCR3NR2P5GPKDCIS2AEWCFSOLVFU",
"counter_amount": "4.3080953",
"counter_asset_type": "native",
"base_is_seller": true,
"price": {
"n": "430809521",
"d": "100000000"
}
},
{
"_links": {
"self": {
"href": ""
},
"base": {
"href": "https://horizon-testnet.stellar.org/accounts/GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS"
},
"counter": {
"href": "https://horizon-testnet.stellar.org/accounts/GBNDB4UHLDRBLR35JNU4ADYG3J5WA4LJZOPBXMNHZKTKSL37BDX4UBQY"
},
"operation": {
"href": "https://horizon-testnet.stellar.org/operations/83056000260648961"
}
},
"id": "83056000260648961-0",
"paging_token": "83056000260648961-0",
"ledger_close_time": "2018-08-07T18:27:33Z",
"offer_id": "23400441",
"base_offer_id": "23400441",
"base_account": "GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS",
"base_amount": "1.0000000",
"base_asset_type": "credit_alphanum4",
"base_asset_code": "USD",
"base_asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
"counter_offer_id": "4694742018688036865",
"counter_account": "GBNDB4UHLDRBLR35JNU4ADYG3J5WA4LJZOPBXMNHZKTKSL37BDX4UBQY",
"counter_amount": "4.3080953",
"counter_asset_type": "native",
"base_is_seller": true,
"price": {
"n": "430809521",
"d": "100000000"
}
}
]
}
}Supports StreamingThis endpoint supports streaming. To read more about this, visit the streaming section.
Query Parameters
List All Trades
curl --request GET \
--url https://horizon-testnet.stellar.org/tradesimport requests
url = "https://horizon-testnet.stellar.org/trades"
response = requests.get(url)
print(response.text)const options = {method: 'GET'};
fetch('https://horizon-testnet.stellar.org/trades', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://horizon-testnet.stellar.org/trades",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "GET",
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://horizon-testnet.stellar.org/trades"
req, _ := http.NewRequest("GET", url, nil)
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.get("https://horizon-testnet.stellar.org/trades")
.asString();require 'uri'
require 'net/http'
url = URI("https://horizon-testnet.stellar.org/trades")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
response = http.request(request)
puts response.read_body{
"_links": {
"self": {
"href": "https://horizon-testnet.stellar.org/trades?base_asset_code=USD&base_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX&base_asset_type=credit_alphanum4&counter_asset_type=native&cursor=&limit=3&order=asc"
},
"next": {
"href": "https://horizon-testnet.stellar.org/trades?base_asset_code=USD&base_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX&base_asset_type=credit_alphanum4&counter_asset_type=native&cursor=83056000260648961-0&limit=3&order=asc"
},
"prev": {
"href": "https://horizon-testnet.stellar.org/trades?base_asset_code=USD&base_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX&base_asset_type=credit_alphanum4&counter_asset_type=native&cursor=82854686553571330-0&limit=3&order=desc"
}
},
"_embedded": {
"records": [
{
"_links": {
"self": {
"href": ""
},
"base": {
"href": "https://horizon-testnet.stellar.org/accounts/GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS"
},
"counter": {
"href": "https://horizon-testnet.stellar.org/accounts/GBCHK52UXADCQCO7FBA5VBYPGCJFXHCNAVJTMUEKOCCNKJH5F35UZU5T"
},
"operation": {
"href": "https://horizon-testnet.stellar.org/operations/82854686553571330"
}
},
"id": "82854686553571330-0",
"paging_token": "82854686553571330-0",
"ledger_close_time": "2018-08-05T00:55:34Z",
"offer_id": "23074703",
"base_offer_id": "23074703",
"base_account": "GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS",
"base_amount": "22.9174941",
"base_asset_type": "credit_alphanum4",
"base_asset_code": "USD",
"base_asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
"counter_offer_id": "4694540704980959234",
"counter_account": "GBCHK52UXADCQCO7FBA5VBYPGCJFXHCNAVJTMUEKOCCNKJH5F35UZU5T",
"counter_amount": "97.9999800",
"counter_asset_type": "native",
"base_is_seller": true,
"price": {
"n": "106905209",
"d": "25000000"
}
},
{
"_links": {
"self": {
"href": ""
},
"base": {
"href": "https://horizon-testnet.stellar.org/accounts/GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS"
},
"counter": {
"href": "https://horizon-testnet.stellar.org/accounts/GDURV3I6U5OTUV75WWAG2HWZTQHNMCR3NR2P5GPKDCIS2AEWCFSOLVFU"
},
"operation": {
"href": "https://horizon-testnet.stellar.org/operations/83005225157287937"
}
},
"id": "83005225157287937-0",
"paging_token": "83005225157287937-0",
"ledger_close_time": "2018-08-07T02:01:53Z",
"offer_id": "23400441",
"base_offer_id": "23400441",
"base_account": "GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS",
"base_amount": "1.0000000",
"base_asset_type": "credit_alphanum4",
"base_asset_code": "USD",
"base_asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
"counter_offer_id": "4694691243584675841",
"counter_account": "GDURV3I6U5OTUV75WWAG2HWZTQHNMCR3NR2P5GPKDCIS2AEWCFSOLVFU",
"counter_amount": "4.3080953",
"counter_asset_type": "native",
"base_is_seller": true,
"price": {
"n": "430809521",
"d": "100000000"
}
},
{
"_links": {
"self": {
"href": ""
},
"base": {
"href": "https://horizon-testnet.stellar.org/accounts/GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS"
},
"counter": {
"href": "https://horizon-testnet.stellar.org/accounts/GBNDB4UHLDRBLR35JNU4ADYG3J5WA4LJZOPBXMNHZKTKSL37BDX4UBQY"
},
"operation": {
"href": "https://horizon-testnet.stellar.org/operations/83056000260648961"
}
},
"id": "83056000260648961-0",
"paging_token": "83056000260648961-0",
"ledger_close_time": "2018-08-07T18:27:33Z",
"offer_id": "23400441",
"base_offer_id": "23400441",
"base_account": "GD47M25MLSCSYP4SIVNQXVQ4KWNLVGXS4S2AXPTYEJK6OY4VALJWK4BS",
"base_amount": "1.0000000",
"base_asset_type": "credit_alphanum4",
"base_asset_code": "USD",
"base_asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
"counter_offer_id": "4694742018688036865",
"counter_account": "GBNDB4UHLDRBLR35JNU4ADYG3J5WA4LJZOPBXMNHZKTKSL37BDX4UBQY",
"counter_amount": "4.3080953",
"counter_asset_type": "native",
"base_is_seller": true,
"price": {
"n": "430809521",
"d": "100000000"
}
}
]
}
}